--#
--# Quoted Printable Encoding/decoding
--#
--# Usage: qpe(s): returns {es,s1} where:
--#   es is encoded sequence not longer than 76 characters.
--#   s1 is remainder of input not processed or {}.
--#   between 25 and 76 bytes of input will be encoded per call.
--#
--# Usage: qpd(s): returns decoded sequence.
--#
--# Version 0.02. 02/04/02 Fixed bug not handling #00 correctly
--#
sequence printable
constant hex={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'}


global function qpe(sequence in) 
-------------------------------------
integer index, outlen
sequence result

	--#
	--# initialise printable; table of characters which can be sent "as is"
	--#
	printable=repeat(-1,256)
	for i = 39 to 58 do
		printable[i+1]=i			-- '()*+,-./0123456789:
	end for
	printable[42+1]=-1			-- not *
	printable[63+1]=63			-- ? is OK		
	for i = 65 to 90 do
		printable[i+1]=i			-- A..Z
		printable[i+32+1]=i+32	-- a..z
	end for
	result = {}
	if compare(in,".")=0 then
		printable[46+1]=-1
	end if
	if in[1] = 'F'
	or in[1] = 'f' then
	    if in[2] = 'R'
		or in[2] = 'r' then
	    	if in[3] = 'O'
			or in[3] = 'o' then
			    if in[4] = 'M'
				or in[4] = 'm' then		
					printable[70+1]=-1
					printable[102+1]=-1
				end if
			end if
		end if
	end if
	index=1
	outlen=0
	while index <= length(in)
	and outlen<76 do
		if printable[in[index]+1]>0 then
			result&=in[index]
			outlen+=1
			index+=1
		else
			if outlen<74 then
				result&='='&hex[floor(in[index]/16)+1]&hex[remainder(in[index],16)+1]
				index+=1
			end if
			outlen+=3
		end if
	end while

	return {result,in[index..length(in)]}
end function




global function qpd(sequence in) 
-------------------------------------
sequence result
sequence hout
integer k

	hout=repeat(0,256)
	for i = 1 to 9 do
		hout[i+48]=i	-- '1'..'9' ['0' is already 0]
	end for
	for i = 10 to 15 do
		hout[i+55]=i	-- 'A'..'F'
		hout[i+87]=i	-- 'a'..'f'
	end for
	result={}
	k=1
	while k <= length(in) do
		if in[k]='=' then
			result&=hout[in[k+1]]*16+hout[in[k+2]]
			k+=3
		else
			result&=in[k]
			k+=1
		end if
	end while
	return result
end function